"""Add acquiring models

Revision ID: 87b793f35b89
Revises: 
Create Date: 2024-04-13 08:12:25.061773

"""
from typing import Sequence, Union

from alembic import op
import sqlalchemy as sa


# revision identifiers, used by Alembic.
revision: str = '87b793f35b89'
down_revision: Union[str, None] = None
branch_labels: Union[str, Sequence[str], None] = None
depends_on: Union[str, Sequence[str], None] = None


def upgrade() -> None:
    op.create_table('acquiring_paymentattempts',
        sa.Column('id', sa.String(), nullable=False),
        sa.Column('created_at', sa.TIMESTAMP(timezone=True), nullable=False),
        sa.PrimaryKeyConstraint('id')
    )
    op.create_table('acquiring_paymentmethods',
        sa.Column('id', sa.String(), nullable=False),
        sa.Column('created_at', sa.TIMESTAMP(timezone=True), nullable=False),
        sa.Column('confirmable', sa.Boolean(), server_default='False', nullable=False),
        sa.Column('payment_attempt_id', sa.String(), nullable=False),
        sa.ForeignKeyConstraint(['payment_attempt_id'], ['acquiring_paymentattempts.id'], ),
        sa.PrimaryKeyConstraint('id')
    )


def downgrade() -> None:
    # ### commands auto generated by Alembic - please adjust! ###
    op.drop_table('acquiring_paymentmethods')
    op.drop_table('acquiring_paymentattempts')
    # ### end Alembic commands ###
