# 11. Adoption Is All That Matters

Date: 2024-05-06

From [Worse Is Better](https://dreamsongs.com/WorseIsBetter.html)


## It is better to start with a minimal creation and grow it as needed

Christopher Alexander might call this "piecemeal growth".

This concept was first elaborated by Richard P Gabriel, and it's based on the following ideas:

1. It is more important for the implementation to be simpler than the interface. (Simplicity)
2. It is slightly better to be simple than correct. (Correctness)
3. It is better to drop parts of the design that deal with less common circumstances than to introduce either complexity or inconsistency. (Consistency)
4. All reasonably expected cases should be covered. (Completeness)

Gabriel argued that "Worse is better" produced more successful software than the MIT approach: As long as the initial program is basically good,
it will take much less time and effort to implement initially and it will be easier to adapt to new situations.

