# README

## Introduction to Acquiring's Architecture Decisions

The documents in this folder cover how `acquiring` has been designed and how it works. It's intended to aid in
understanding the code, and hopefully to enable people to modify it.

Many of this design decisions have been made as the project has grown. Personally, that's how most of the programming
decisions I've made have happened. For that reason, I decided to document the architecture decisions I've been making
along the way.

[People without dirty hands are wrong](https://medium.com/@bre/the-cult-of-done-manifesto-724ca1c2ff13).

Decisions, therefore, are short notes on guiding principles that informed both the high level breakdown and the low
level implementation details of this project. Everything is a draft, because it helps to get it done.

This idea is not new. It is heavily inspired by a post by
[Michael Nygard](https://cognitect.com/blog/2011/11/15/documenting-architecture-decisions), who is behind the concept of
[Architectural Decision Records](https://adr.github.io/), or ADRs.

The problem with ADRs is that they enforce a structure that is too rigid and not very stimulating to read.

Instead, a decision can have any structure, but it has to conform to five important rules:

1. It must be concise
2. It must be complete
3. It must be easy to understand
4. It must be pleasant to read
5. Once it's committed, it must never be edited.


[ADR 0001](/architecture/decisions/0001-record-architecture-decisions) is left the way ADRs are meant to be written. The
 rest, though, conform to these rules.
